<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductSearchCriteriaContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q8:ArrayOfProductSearchCriteriaContract
 * @subpackage Arrays
 */
class ArrayOfProductSearchCriteriaContract extends AbstractStructArrayBase
{
    /**
     * The ProductSearchCriteriaContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductSearchCriteriaContract[]
     */
    public $ProductSearchCriteriaContract;
    /**
     * Constructor method for ArrayOfProductSearchCriteriaContract
     * @uses ArrayOfProductSearchCriteriaContract::setProductSearchCriteriaContract()
     * @param \StructType\ProductSearchCriteriaContract[] $productSearchCriteriaContract
     */
    public function __construct(array $productSearchCriteriaContract = array())
    {
        $this
            ->setProductSearchCriteriaContract($productSearchCriteriaContract);
    }
    /**
     * Get ProductSearchCriteriaContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductSearchCriteriaContract[]|null
     */
    public function getProductSearchCriteriaContract()
    {
        return isset($this->ProductSearchCriteriaContract) ? $this->ProductSearchCriteriaContract : null;
    }
    /**
     * Set ProductSearchCriteriaContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductSearchCriteriaContract[] $productSearchCriteriaContract
     * @return \ArrayType\ArrayOfProductSearchCriteriaContract
     */
    public function setProductSearchCriteriaContract(array $productSearchCriteriaContract = array())
    {
        foreach ($productSearchCriteriaContract as $arrayOfProductSearchCriteriaContractProductSearchCriteriaContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductSearchCriteriaContractProductSearchCriteriaContractItem instanceof \StructType\ProductSearchCriteriaContract) {
                throw new \InvalidArgumentException(sprintf('The ProductSearchCriteriaContract property can only contain items of \StructType\ProductSearchCriteriaContract, "%s" given', is_object($arrayOfProductSearchCriteriaContractProductSearchCriteriaContractItem) ? get_class($arrayOfProductSearchCriteriaContractProductSearchCriteriaContractItem) : gettype($arrayOfProductSearchCriteriaContractProductSearchCriteriaContractItem)), __LINE__);
            }
        }
        if (is_null($productSearchCriteriaContract) || (is_array($productSearchCriteriaContract) && empty($productSearchCriteriaContract))) {
            unset($this->ProductSearchCriteriaContract);
        } else {
            $this->ProductSearchCriteriaContract = $productSearchCriteriaContract;
        }
        return $this;
    }
    /**
     * Add item to ProductSearchCriteriaContract value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductSearchCriteriaContract $item
     * @return \ArrayType\ArrayOfProductSearchCriteriaContract
     */
    public function addToProductSearchCriteriaContract(\StructType\ProductSearchCriteriaContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductSearchCriteriaContract) {
            throw new \InvalidArgumentException(sprintf('The ProductSearchCriteriaContract property can only contain items of \StructType\ProductSearchCriteriaContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProductSearchCriteriaContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductSearchCriteriaContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductSearchCriteriaContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductSearchCriteriaContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductSearchCriteriaContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductSearchCriteriaContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductSearchCriteriaContract
     */
    public function getAttributeName()
    {
        return 'ProductSearchCriteriaContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProductSearchCriteriaContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
