<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStoxWebLocationContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q54:ArrayOfStoxWebLocationContract
 * @subpackage Arrays
 */
class ArrayOfStoxWebLocationContract extends AbstractStructArrayBase
{
    /**
     * The StoxWebLocationContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StoxWebLocationContract[]
     */
    public $StoxWebLocationContract;
    /**
     * Constructor method for ArrayOfStoxWebLocationContract
     * @uses ArrayOfStoxWebLocationContract::setStoxWebLocationContract()
     * @param \StructType\StoxWebLocationContract[] $stoxWebLocationContract
     */
    public function __construct(array $stoxWebLocationContract = array())
    {
        $this
            ->setStoxWebLocationContract($stoxWebLocationContract);
    }
    /**
     * Get StoxWebLocationContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StoxWebLocationContract[]|null
     */
    public function getStoxWebLocationContract()
    {
        return isset($this->StoxWebLocationContract) ? $this->StoxWebLocationContract : null;
    }
    /**
     * Set StoxWebLocationContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StoxWebLocationContract[] $stoxWebLocationContract
     * @return \ArrayType\ArrayOfStoxWebLocationContract
     */
    public function setStoxWebLocationContract(array $stoxWebLocationContract = array())
    {
        foreach ($stoxWebLocationContract as $arrayOfStoxWebLocationContractStoxWebLocationContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfStoxWebLocationContractStoxWebLocationContractItem instanceof \StructType\StoxWebLocationContract) {
                throw new \InvalidArgumentException(sprintf('The StoxWebLocationContract property can only contain items of \StructType\StoxWebLocationContract, "%s" given', is_object($arrayOfStoxWebLocationContractStoxWebLocationContractItem) ? get_class($arrayOfStoxWebLocationContractStoxWebLocationContractItem) : gettype($arrayOfStoxWebLocationContractStoxWebLocationContractItem)), __LINE__);
            }
        }
        if (is_null($stoxWebLocationContract) || (is_array($stoxWebLocationContract) && empty($stoxWebLocationContract))) {
            unset($this->StoxWebLocationContract);
        } else {
            $this->StoxWebLocationContract = $stoxWebLocationContract;
        }
        return $this;
    }
    /**
     * Add item to StoxWebLocationContract value
     * @throws \InvalidArgumentException
     * @param \StructType\StoxWebLocationContract $item
     * @return \ArrayType\ArrayOfStoxWebLocationContract
     */
    public function addToStoxWebLocationContract(\StructType\StoxWebLocationContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StoxWebLocationContract) {
            throw new \InvalidArgumentException(sprintf('The StoxWebLocationContract property can only contain items of \StructType\StoxWebLocationContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StoxWebLocationContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StoxWebLocationContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StoxWebLocationContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StoxWebLocationContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StoxWebLocationContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StoxWebLocationContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StoxWebLocationContract
     */
    public function getAttributeName()
    {
        return 'StoxWebLocationContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfStoxWebLocationContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
