<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStoxWebProductContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q16:ArrayOfStoxWebProductContract
 * @subpackage Arrays
 */
class ArrayOfStoxWebProductContract extends AbstractStructArrayBase
{
    /**
     * The StoxWebProductContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StoxWebProductContract[]
     */
    public $StoxWebProductContract;
    /**
     * Constructor method for ArrayOfStoxWebProductContract
     * @uses ArrayOfStoxWebProductContract::setStoxWebProductContract()
     * @param \StructType\StoxWebProductContract[] $stoxWebProductContract
     */
    public function __construct(array $stoxWebProductContract = array())
    {
        $this
            ->setStoxWebProductContract($stoxWebProductContract);
    }
    /**
     * Get StoxWebProductContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StoxWebProductContract[]|null
     */
    public function getStoxWebProductContract()
    {
        return isset($this->StoxWebProductContract) ? $this->StoxWebProductContract : null;
    }
    /**
     * Set StoxWebProductContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StoxWebProductContract[] $stoxWebProductContract
     * @return \ArrayType\ArrayOfStoxWebProductContract
     */
    public function setStoxWebProductContract(array $stoxWebProductContract = array())
    {
        foreach ($stoxWebProductContract as $arrayOfStoxWebProductContractStoxWebProductContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfStoxWebProductContractStoxWebProductContractItem instanceof \StructType\StoxWebProductContract) {
                throw new \InvalidArgumentException(sprintf('The StoxWebProductContract property can only contain items of \StructType\StoxWebProductContract, "%s" given', is_object($arrayOfStoxWebProductContractStoxWebProductContractItem) ? get_class($arrayOfStoxWebProductContractStoxWebProductContractItem) : gettype($arrayOfStoxWebProductContractStoxWebProductContractItem)), __LINE__);
            }
        }
        if (is_null($stoxWebProductContract) || (is_array($stoxWebProductContract) && empty($stoxWebProductContract))) {
            unset($this->StoxWebProductContract);
        } else {
            $this->StoxWebProductContract = $stoxWebProductContract;
        }
        return $this;
    }
    /**
     * Add item to StoxWebProductContract value
     * @throws \InvalidArgumentException
     * @param \StructType\StoxWebProductContract $item
     * @return \ArrayType\ArrayOfStoxWebProductContract
     */
    public function addToStoxWebProductContract(\StructType\StoxWebProductContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StoxWebProductContract) {
            throw new \InvalidArgumentException(sprintf('The StoxWebProductContract property can only contain items of \StructType\StoxWebProductContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StoxWebProductContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StoxWebProductContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StoxWebProductContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StoxWebProductContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StoxWebProductContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StoxWebProductContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StoxWebProductContract
     */
    public function getAttributeName()
    {
        return 'StoxWebProductContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfStoxWebProductContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
