<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStoxWebQuantityContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q24:ArrayOfStoxWebQuantityContract
 * @subpackage Arrays
 */
class ArrayOfStoxWebQuantityContract extends AbstractStructArrayBase
{
    /**
     * The StoxWebQuantityContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StoxWebQuantityContract[]
     */
    public $StoxWebQuantityContract;
    /**
     * Constructor method for ArrayOfStoxWebQuantityContract
     * @uses ArrayOfStoxWebQuantityContract::setStoxWebQuantityContract()
     * @param \StructType\StoxWebQuantityContract[] $stoxWebQuantityContract
     */
    public function __construct(array $stoxWebQuantityContract = array())
    {
        $this
            ->setStoxWebQuantityContract($stoxWebQuantityContract);
    }
    /**
     * Get StoxWebQuantityContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StoxWebQuantityContract[]|null
     */
    public function getStoxWebQuantityContract()
    {
        return isset($this->StoxWebQuantityContract) ? $this->StoxWebQuantityContract : null;
    }
    /**
     * Set StoxWebQuantityContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StoxWebQuantityContract[] $stoxWebQuantityContract
     * @return \ArrayType\ArrayOfStoxWebQuantityContract
     */
    public function setStoxWebQuantityContract(array $stoxWebQuantityContract = array())
    {
        foreach ($stoxWebQuantityContract as $arrayOfStoxWebQuantityContractStoxWebQuantityContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfStoxWebQuantityContractStoxWebQuantityContractItem instanceof \StructType\StoxWebQuantityContract) {
                throw new \InvalidArgumentException(sprintf('The StoxWebQuantityContract property can only contain items of \StructType\StoxWebQuantityContract, "%s" given', is_object($arrayOfStoxWebQuantityContractStoxWebQuantityContractItem) ? get_class($arrayOfStoxWebQuantityContractStoxWebQuantityContractItem) : gettype($arrayOfStoxWebQuantityContractStoxWebQuantityContractItem)), __LINE__);
            }
        }
        if (is_null($stoxWebQuantityContract) || (is_array($stoxWebQuantityContract) && empty($stoxWebQuantityContract))) {
            unset($this->StoxWebQuantityContract);
        } else {
            $this->StoxWebQuantityContract = $stoxWebQuantityContract;
        }
        return $this;
    }
    /**
     * Add item to StoxWebQuantityContract value
     * @throws \InvalidArgumentException
     * @param \StructType\StoxWebQuantityContract $item
     * @return \ArrayType\ArrayOfStoxWebQuantityContract
     */
    public function addToStoxWebQuantityContract(\StructType\StoxWebQuantityContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StoxWebQuantityContract) {
            throw new \InvalidArgumentException(sprintf('The StoxWebQuantityContract property can only contain items of \StructType\StoxWebQuantityContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StoxWebQuantityContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StoxWebQuantityContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StoxWebQuantityContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StoxWebQuantityContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StoxWebQuantityContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StoxWebQuantityContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StoxWebQuantityContract
     */
    public function getAttributeName()
    {
        return 'StoxWebQuantityContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfStoxWebQuantityContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
