<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StoxWebLocationResponseContract StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q52:StoxWebLocationResponseContract
 * @subpackage Structs
 */
class StoxWebLocationResponseContract extends AbstractStructBase
{
    /**
     * The StoxWebLocations
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfStoxWebLocationContract
     */
    public $StoxWebLocations;
    /**
     * The Success
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Success;
    /**
     * The Errors
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfanyType
     */
    public $Errors;
    /**
     * Constructor method for StoxWebLocationResponseContract
     * @uses StoxWebLocationResponseContract::setStoxWebLocations()
     * @uses StoxWebLocationResponseContract::setSuccess()
     * @uses StoxWebLocationResponseContract::setErrors()
     * @param \ArrayType\ArrayOfStoxWebLocationContract $stoxWebLocations
     * @param bool $success
     * @param \ArrayType\ArrayOfanyType $errors
     */
    public function __construct(\ArrayType\ArrayOfStoxWebLocationContract $stoxWebLocations = null, $success = null, \ArrayType\ArrayOfanyType $errors = null)
    {
        $this
            ->setStoxWebLocations($stoxWebLocations)
            ->setSuccess($success)
            ->setErrors($errors);
    }
    /**
     * Get StoxWebLocations value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfStoxWebLocationContract|null
     */
    public function getStoxWebLocations()
    {
        return isset($this->StoxWebLocations) ? $this->StoxWebLocations : null;
    }
    /**
     * Set StoxWebLocations value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfStoxWebLocationContract $stoxWebLocations
     * @return \StructType\StoxWebLocationResponseContract
     */
    public function setStoxWebLocations(\ArrayType\ArrayOfStoxWebLocationContract $stoxWebLocations = null)
    {
        if (is_null($stoxWebLocations) || (is_array($stoxWebLocations) && empty($stoxWebLocations))) {
            unset($this->StoxWebLocations);
        } else {
            $this->StoxWebLocations = $stoxWebLocations;
        }
        return $this;
    }
    /**
     * Get Success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\StoxWebLocationResponseContract
     */
    public function setSuccess($success = null)
    {
        $this->Success = $success;
        return $this;
    }
    /**
     * Get Errors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfanyType|null
     */
    public function getErrors()
    {
        return isset($this->Errors) ? $this->Errors : null;
    }
    /**
     * Set Errors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfanyType $errors
     * @return \StructType\StoxWebLocationResponseContract
     */
    public function setErrors(\ArrayType\ArrayOfanyType $errors = null)
    {
        if (is_null($errors) || (is_array($errors) && empty($errors))) {
            unset($this->Errors);
        } else {
            $this->Errors = $errors;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StoxWebLocationResponseContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
